exec("./AdminApp_Form.GUI");
exec("./AdminApp_Review.GUI");
exec("./AdminApp_Response.GUI");

AdminApp_Review.folder = "";
AdminApp_Review.host = "";
AdminApp_Review.listToggle = 0;

$AdminApp::Version = 1;
$AdminApp::FilePath = "config/server/AdminApps/";

if(!$AdminAppGUI)
{
	$remapDivision[$remapCount] = "Admin Applications";
	$remapName[$remapCount] = "Toggle Admin App GUI";
	$remapCmd[$remapCount] = "AdminApp_ToggleGUI";
	$remapCount++;
	
	$AdminAppGUI = 1;
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//Toggle Relative GUI (depend if host or not)

function AdminApp_ToggleGUI(%toggle)
{
	if(!%toggle)
		return;
	
	if(!$ServerHasAdminAppMod)
	{
		messageboxOk("Admin App - ERROR", "This server isn't using the Admin App Add-On.");
		return;
	}

	if(AdminApp_Review.host $= "") //determine if player is host or not
	{
		commandToServer('AdminApp_DetermineGUI');
		return;
	}

	if(AdminApp_Review.host $= "Host") //if player is host
	{
		if(AdminApp_Review.isAwake())
			canvas.popDialog(AdminApp_Review);
		else
		{
			canvas.pushDialog(AdminApp_Review);
			AdminAppReview_AppList.clear();
		}
	}
	else
	{
		if(!$IAmAdmin) //prevent opening form gui if already admin / super-admin
		{
			if(AdminApp_Form.isAwake())
				canvas.popDialog(AdminApp_Form);
			else
				canvas.pushDialog(AdminApp_Form);
		}
		else
			messageboxOk("Admin App - ERROR", "You can't apply for admin if you already have an administrative position!");
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//Set up isHost GUI method and open relative GUI (should be executed only once by server)

function clientCmdAdminApp_setGUI(%isHost,%reApplyLimit)
{
	AdminApp_Review.host = %isHost;
	
	if(%isHost $= "Host")
	{
		canvas.pushDialog(AdminApp_Review);
		AdminAppReview_ReApplyLimits.setSelected(%reApplyLimit); //takes null string into account; = 0
	}
	else
		canvas.pushDialog(AdminApp_Form);
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//Setup var that determines if server is running the admin app add-on

function clientCmdAdminApp_hasMod(%bool)
{
	$ServerHasAdminAppMod = %bool;
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//[Host-Only] Update host's app list after responding

function clientCmdAdminApp_RelayRefreshAppList()
{
	if(AdminApp_Review.folder $= "")
		return;
	
	%catName = AdminApp_Review.folder;
	AdminApp_RefreshGUIAppList(AdminApp_Review.folder,%catName);
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//When a player submits an application form to the server host (host doesn't have to be present to receive it)

function AdminApp_Form::done(%gui, %confirm)
{
	if(!%confirm)
	{
		messageBoxYesNo("Admin App - Confirmation", "Are you sure you're ready to submit your application? Make sure you review it thoroughly, as you won\'t be able to edit it afterwards. There are also limits for resubmission.", "AdminApp_Form.done(1);");
		return;
	}

	%PrevAdminExp = AdminAppForm_ExperienceText.getText();
	%WhoRec = AdminAppForm_RecommendationsText.getText();
	%WhyAccept = AdminAppForm_WhyText.getText();
	%TimeZone = AdminAppForm_Timezone.getValue();
	
	if(AdminAppForm_SuperAdminRadio.getValue())
		%adminType = 2;
	else
		%adminType = 1;
	
	//////////////////////////////////////////////////
	//Checks to run before submitting
	
	if(strReplace(%PrevAdminExp, " ", "") $= "" || %PrevAdminExp $= "[Insert a list of servers where you were/are an admin on here.]")
	{
		messageboxOk("Admin App - ERROR", "No previous admin experience was included in your application!");
		return;
	}
	if(strReplace(%WhoRec, " ", "") $= "" || %WhoRec $= "[Insert list of people who recommend you here. Include Blockland IDs.]")
	{
		messageboxOk("Admin App - ERROR", "No recommendations were included in your application!");
		return;
	}
	if(strReplace(%WhyAccept, " ", "") $= "" || %WhyAccept $= "[Insert a paragraph of why you should be accepted here.]")
	{
		messageboxOk("Admin App - ERROR", "No information regarding why you should be accepted was included in your application!");
		return;
	}
	if(!%AdminType) //Can't happen unless they borked it on purpose. //borked?
	{
		messageboxOk("Admin App - ERROR", "No specified admin type to apply for was included in your application!");
		return;
	}
	if(AdminAppForm_Timezone.getSelected() == 0)
	{
		messageboxOk("Admin App - ERROR", "No timezone selected.");
		return;
	}
	
	//////////////////////////////////////////////////
	//Send app data across network to host
	
	for(%c = 0; %c <= 2040 && %c < strLen(%PrevAdminExp); %c+= 255)
		commandToServer('adminApp_receiveForm', "PrevAdminExp", getSubStr(%PrevAdminExp,%c,255));

	for(%c = 0; %c <= 2040 && %c < strLen(%WhoRec); %c += 255)
		commandToServer('adminApp_receiveForm', "WhoRec", getSubStr(%WhoRec,%c,255));

	for(%c = 0; %c <= 2040 && %c < strLen(%WhyAccept); %c += 255)
		commandToServer('adminApp_receiveForm', "WhyAccept", getSubStr(%WhyAccept,%c,255));

	commandToServer('adminApp_receiveForm', "TimeZone", %TimeZone);
	commandToServer('adminApp_receiveForm', "AdminType", %adminType);
	
	commandToServer('adminApp_finalSubmitForm');
	canvas.popDialog(AdminApp_Form);
	
	%gui.resetForm();
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//case 1&2 = if deny or blacklist response selected, case 3&4 = if deny or blacklist response confirmed

function AdminApp_ResponseGUI(%action,%id)
{
	switch(%action)
	{
		case 1: //Open response gui for denying a player
			if(%id $= "" || %id $= " ")
				return;
				
			AdminApp_Response.plyrID = %id;
			AdminAppResponse_IntroText.setText("<just:center>Are you sure you want to Deny this player? Make sure to enter a reason for doing so below:");
			AdminAppResponse_ResponseButton.mColor = "255 100 100 255";
			AdminAppResponse_ResponseButton.text = "Deny";
			AdminAppResponse_ResponseButton.command = "AdminApp_ResponseGUI(3,\"\");";
			canvas.pushDialog(AdminApp_Response);
		case 2: //Open response gui for blacklisting a player
			if(%id $= "" || %id $= " ")
				return;
				
			AdminApp_Response.plyrID = %id;
			AdminAppResponse_IntroText.setText("<just:center>Are you sure you want to Blacklist this player? Make sure to enter a reason for doing so below:");
			AdminAppResponse_ResponseButton.mColor = "150 150 150 255";
			AdminAppResponse_ResponseButton.text = "Blacklist";
			AdminAppResponse_ResponseButton.command = "AdminApp_ResponseGUI(4,\"\");";
			canvas.pushDialog(AdminApp_Response);
		case 3: //Deny player from response gui
			%text = AdminAppResponse_ReasonText.getText();
			%textCheck = strReplace(%text," ","");
			if(%textCheck !$= "" && %textCheck !$= "[Reason]")
			{
				commandToServer('AdminApp_Review',AdminApp_Response.plyrID,0,%text);
				AdminApp_Response.plyrID = "";
				AdminAppResponse_ReasonText.setText(""); //.text = ""; sets default text
				canvas.popDialog(AdminApp_Response);
			}
			else
				messageboxOk("Admin App - ERROR", "Make sure to enter a reason for denying this player's application.");
		case 4: //Blacklist player from response gui
			%text = AdminAppResponse_ReasonText.getText();
			%textCheck = strReplace(%text," ","");
			if(%textCheck !$= "" && %textCheck !$= "[Reason]")
			{
				commandToServer('AdminApp_Review',AdminApp_Response.plyrID,-1,%text);
				AdminApp_Response.plyrID = "";
				AdminAppResponse_ReasonText.setText(""); //.text = ""; sets default text
				canvas.popDialog(AdminApp_Response);
			}
			else
				messageboxOk("Admin App - ERROR", "Make sure to enter a reason for blacklisting this player's application.");
		default:
			echo("\c2>>> Admin App ERROR -> AdminApp_ResponseGUI -> Switch at line 219 reverted to default case due to unknown issue.");
			return;
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//Clear form gui default text or pre-entered text

function AdminApp_Form::resetForm(%gui)
{
	AdminAppForm_ExperienceText.setText("");
	AdminAppForm_RecommendationsText.setText("");
	AdminAppForm_WhyText.setText("");
	AdminAppForm_Timezone.setSelected(-1); //sets to null selection (dont' set to zero)
	AdminAppForm_Timezone.setText("Please Select One:");
	AdminAppForm_AdminRadio.setValue(1);
	AdminAppForm_SuperAdminRadio.setValue(0);
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//[Host-Only] Select a category of apps to list

function AdminApp_RefreshGUIAppList(%folder,%catName)
{
	if(AdminApp_Review.host !$= "Host")
		return;
	
	if(%folder $= "Denied")
	{
		AdminAppReview_RespAdmin.enabled = 0;
		AdminAppReview_RespSAdmin.enabled = 0;
		AdminAppReview_RespDeny.enabled = 1;
		AdminAppReview_RespBlacklist.enabled = 0;
		
		AdminAppReview_RespAdmin.mColor = "100 255 100 100";
		AdminAppReview_RespSAdmin.mColor = "100 100 255 100";
		AdminAppReview_RespDeny.mColor = "255 100 100 255";
		AdminAppReview_RespBlacklist.mColor = "150 150 150 100";
		
		AdminAppReview_RespBlacklist.text = "Blacklist";
		AdminAppReview_RespDeny.text = "unDeny";
		
		AdminAppReview_RespBlacklist.command = "if(adminappreview_applist.getvalue() !$= \"\")AdminApp_ResponseGUI(2,getword(adminappreview_applist.getvalue(),0));";
		AdminAppReview_RespDeny.command = "if(adminappreview_applist.getvalue() !$= \"\")commandToServer('AdminApp_unDeny',getword(adminappreview_applist.getvalue(),0));";
	}
	else if(%folder $= "Blacklisted")
	{
		AdminAppReview_RespAdmin.enabled = 0;
		AdminAppReview_RespSAdmin.enabled = 0;
		AdminAppReview_RespDeny.enabled = 0;
		AdminAppReview_RespBlacklist.enabled = 1;
		
		AdminAppReview_RespAdmin.mColor = "100 255 100 100";
		AdminAppReview_RespSAdmin.mColor = "100 100 255 100";
		AdminAppReview_RespDeny.mColor = "255 100 100 100";
		AdminAppReview_RespBlacklist.mColor = "150 150 150 255";
		
		AdminAppReview_RespBlacklist.text = "UnBlacklist";
		AdminAppReview_RespDeny.text = "Deny";
		
		AdminAppReview_RespBlacklist.command = "if(adminappreview_applist.getvalue() !$= \"\")commandToServer('AdminApp_unBlacklist',getword(adminappreview_applist.getvalue(),0));";
		AdminAppReview_RespDeny.command = "if(adminappreview_applist.getvalue() !$= \"\")AdminApp_ResponseGUI(1,getword(adminappreview_applist.getvalue(),0));";
	}
	else //Pending
	{
		AdminAppReview_RespAdmin.enabled = 1;
		AdminAppReview_RespSAdmin.enabled = 1;
		AdminAppReview_RespDeny.enabled = 1;
		AdminAppReview_RespBlacklist.enabled = 1;
		
		AdminAppReview_RespAdmin.mColor = "100 255 100 255";
		AdminAppReview_RespSAdmin.mColor = "100 100 255 255";
		AdminAppReview_RespDeny.mColor = "255 100 100 255";
		AdminAppReview_RespBlacklist.mColor = "150 150 150 255";
		
		AdminAppReview_RespBlacklist.text = "Blacklist";
		AdminAppReview_RespDeny.text = "Deny";
		
		AdminAppReview_RespBlacklist.command = "if(adminappreview_applist.getvalue() !$= \"\")AdminApp_ResponseGUI(2,getword(adminappreview_applist.getvalue(),0));";
		AdminAppReview_RespDeny.command = "if(adminappreview_applist.getvalue() !$= \"\")AdminApp_ResponseGUI(1,getword(adminappreview_applist.getvalue(),0));";
	}
	
	//////////////////////////////////////////////////
	
	AdminApp_Review.folder = %folder;
	AdminAppReview_Category.setText("<just:center><color:ffffff><font:impact:26>" @ %catName @ " Apps");
	AdminAppReview_AppList.clear();
	
	%file = new FileObject();
	%filePath = $AdminApp::FilePath @ %folder @ "/*.txt";
	%fileCount = getFileCount(%filePath);
	
	for(%c=0; %c<%fileCount; %c++)
	{
		if(%c<1)
			%findFile = findFirstFile(%filePath);
		else
			%findFile = findNextFile(%filePath);
		
		%fileArray[%c] = fileName(%findFile);
	}
	
	for(%c=0; %c<%fileCount; %c++)
	{
		%filePath = $AdminApp::FilePath @ %folder @ "/" @ %fileArray[%c];
		%file.openForRead(%filePath);
		
		%line = %file.readLine();
		%plyrName = getWords(%line,4,getWordCount(%line)); //%plyrName = strReplace(getWord(%file.readLine(),4),"\"","");
		%plyrBLID = getWord(%file.readLine(),2); //or use file name
		AdminAppReview_AppList.addRow(%c,%plyrBLID TAB %plyrName);
		
		%file.close();
	}
	if(%fileCount == 0)
		%file.close();
		
	%file.delete();
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//[Host-Only] Adds application information about selected player to Host's GUI

function AdminApp_AppListSelect()
{
	if(AdminApp_Review.host !$= "Host")
		return;
		
	%fileByID = getWord(AdminAppReview_AppList.getvalue(),0);
	%folder = AdminApp_Review.folder;
	
	%filePath = $AdminApp::FilePath @ %folder @ "/" @ %fileByID @ ".txt";
	
	if(isFile(%filePath))
	{
		%file = new FileObject();
		%file.openForRead(%filePath);
		
		%file.readLine();
		%file.readLine();
		
		%PrevExpText = %file.readLine();
		AdminAppReview_PrevExpText.setText("<font:calibri:16>" @ getWords(%PrevExpText,3,getWordCount(%PrevExpText)));
		
		%WhoRecText = %file.readLine();
		AdminAppReview_WhoRecText.setText("<font:calibri:16>" @ getWords(%WhoRecText,3,getWordCount(%WhoRecText)));
		
		%WhyAcceptText = %file.readLine();
		AdminAppReview_WhyAcceptText.setText("<font:calibri:16>" @ getWords(%WhyAcceptText,5,getWordCount(%WhyAcceptText)));
		
		%TimeZoneText = %file.readLine();
		AdminAppReview_TimeZoneText.setText("<font:calibri:20>" @ getWords(%TimeZoneText,1,getWordCount(%TimeZoneText)));
		
		%SentText = %file.readLine();
		
		%date = getWord(%SentText,1);
		%time = getWord(%SentText,2);
		%newTime = strReplace(%time,":"," ");
		%hour = getWord(%newTime,0);
		
		if(%hour > 11) //convert army time to normal time
		{
			if(%hour > 12)
				%newTime = setWord(%newTime,0,%hour-12);
				
			%tod = "pm";
		}
		else
			%tod = "am";
			
		AdminAppReview_SentText.setText("<font:calibri:20>" @ %date SPC getWord(%newTime,0) @ ":" @ getWord(%newTime,1) @ %tod);

		%AdminPosText = %file.readLine();
		AdminAppReview_AdminPosText.setText("<font:calibri:20>" @ getWord(%AdminPosText,2));
		
		%file.close();
		%file.delete();
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//[Host-Only] Toggles sorting application list chronologically and numerically (by ID), also in ascending or descending order

function AdminApp_SortAppList(%method)
{
	if(AdminApp_Review.host !$= "Host")
		return;
	
	if(%method == 0)
		AdminAppReview_AppList.sortNumerical(0,AdminApp_Review.listToggle);
	else if(%method == 1) 
		AdminAppReview_AppList.sort(1,AdminApp_Review.listToggle);
	else
	{
		AdminAppReview_AppList.setProfile(getWord("GUITextListProfile PlayerListProfile",AdminApp_Review.listToggle));
		
		canvas.popDialog(AdminApp_Review);
		canvas.pushDialog(AdminApp_Review);
	}
		
	if(!AdminApp_Review.listToggle)
		AdminApp_Review.listToggle = 1;
	else
		AdminApp_Review.listToggle = 0;
}

////////////////////////////////////////////////////////////////////////////////////////////////////

package AdminApp_Client
{
	//////////////////////////////////////////////////
	//Sync-check client's version of add-on against server's version
	
	function gameConnection::setConnectArgs(%client, %b, %c, %d, %e, %f, %g, %h, %i, %j)
	{
		parent::setConnectArgs(%client, %b, %c, %d, %e, %f, %g, %h, %i, "AdminApp" TAB $AdminApp::Version);
	}
	
	//////////////////////////////////////////////////
	//Reset client variable and methods on server disconnect
	
	function disconnect()
	{
		parent::disconnect();

		$ServerHasAdminAppMod = 0;
		
		AdminApp_Review.host = "";
		AdminApp_Review.folder = "";
		AdminApp_Review.listToggle = 0;
	}
};
activatePackage(AdminApp_Client);